'use strict';

Object.defineProperty(exports, '__esModule', {
	value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _lodashCamelcase = require('lodash.camelcase');

var _lodashCamelcase2 = _interopRequireDefault(_lodashCamelcase);

var _constants = require('./constants');

var ElectronWebView = (function (_Component) {
	_inherits(ElectronWebView, _Component);

	function ElectronWebView() {
		_classCallCheck(this, ElectronWebView);

		_get(Object.getPrototypeOf(ElectronWebView.prototype), 'constructor', this).apply(this, arguments);
	}

	_createClass(ElectronWebView, [{
		key: 'componentDidMount',
		value: function componentDidMount() {
			var _this = this;

			var container = _reactDom2['default'].findDOMNode(this.c);
			var propString = '';
			Object.keys(_constants.props).forEach(function (propName) {
				if (typeof _this.props[propName] !== 'undefined') {
					if (typeof _this.props[propName] === 'boolean') {
						propString += propName + '="' + (_this.props[propName] ? 'on' : 'off') + '" ';
					} else {
						propString += propName + '=' + JSON.stringify(_this.props[propName].toString()) + ' ';
					}
				}
			});
			if (this.props.className) {
				propString += 'class="' + this.props.className + '" ';
			}
			container.innerHTML = '<webview ' + propString + '/>';
			this.view = container.querySelector('webview');

			this.ready = false;
			this.view.addEventListener('did-attach', function () {
				_this.ready = true;
				_constants.events.forEach(function (event) {
					_this.view.addEventListener(event, function () {
						var _props;

						var propName = (0, _lodashCamelcase2['default'])('on-' + event);
						// console.log('Firing event: ', propName, ' has listener: ', !!this.props[propName]);
						if (_this.props[propName]) (_props = _this.props)[propName].apply(_props, arguments);
					});
				});
			});

			_constants.methods.forEach(function (method) {
				_this[method] = function () {
					var _view;

					if (!_this.ready) {
						throw new Error('WebView is not ready yet, you can\'t call this method');
					}
					return (_view = _this.view)[method].apply(_view, arguments);
				};
			});
			this.setDevTools = function (open) {
				if (open && !_this.isDevToolsOpened()) {
					_this.openDevTools();
				} else if (!open && _this.isDevToolsOpened()) {
					_this.closeDevTools();
				}
			};
		}
	}, {
		key: 'componentDidUpdate',
		value: function componentDidUpdate(prevProps) {
			var _this2 = this;

			console.log('Update');
			Object.keys(_constants.changableProps).forEach(function (propName) {
				if (_this2.props[propName] !== prevProps[propName]) {
					if (_constants.changableProps[propName] == '__USE_ATTR__') {
						_this2.view.setAttribute(propName, _this2.props[propName]);
					} else {
						_this2[_constants.changableProps[propName]](_this2.props[propName]);
					}
				}
			});
		}
	}, {
		key: 'isReady',
		value: function isReady() {
			return this.ready;
		}
	}, {
		key: 'render',
		value: function render() {
			var _this3 = this;

			return _react2['default'].createElement('div', { ref: function (c) {
					return _this3.c = c;
				}, style: this.props.style || {} });
		}
	}]);

	return ElectronWebView;
})(_react.Component);

exports['default'] = ElectronWebView;

ElectronWebView.propTypes = _extends({
	className: _react.PropTypes.string,
	style: _react.PropTypes.object
}, _constants.props);

_constants.events.forEach(function (event) {
	ElectronWebView.propTypes[(0, _lodashCamelcase2['default'])('on-' + event)] = _react.PropTypes.func;
});
module.exports = exports['default'];