'use strict';

Object.defineProperty(exports, '__esModule', {
	value: true
});

var _react = require('react');

var events = ['load-commit', 'did-attach', 'did-finish-load', 'did-fail-load', 'did-frame-finish-load', 'did-start-loading', 'did-stop-loading', 'did-get-response-details', 'did-get-redirect-request', 'dom-ready', 'page-title-set', 'page-favicon-updated', 'enter-html-full-screen', 'leave-html-full-screen', 'console-message', 'new-window', 'close', 'ipc-message', 'crashed', 'gpu-crashed', 'plugin-crashed', 'destroyed'];

exports.events = events;
var methods = ['loadURL', 'getURL', 'getTitle', 'isLoading', 'isWaitingForResponse', 'stop', 'reload', 'reloadIgnoringCache', 'canGoBack', 'canGoForward', 'canGoToOffset', 'clearHistory', 'goBack', 'goForward', 'goToIndex', 'goToOffset', 'isCrashed', 'setUserAgent', 'getUserAgent', 'insertCSS', 'executeJavaScript', 'openDevTools', 'closeDevTools', 'isDevToolsOpened', 'isDevToolsFocused', 'inspectElement', 'inspectServiceWorker', 'setAudioMuted', 'isAudioMuted', 'undo', 'redo', 'cut', 'copy', 'paste', 'pasteAndMatchStyle', 'delete', 'selectAll', 'unselect', 'replace', 'replaceMisspelling', 'insertText', 'findInPage', 'stopFindInPage', 'print', 'printToPDF', 'capturePage', 'send', 'sendInputEvent', 'setZoomFactor', 'setZoomLevel', 'showDefinitionForSelection', 'getWebContents', 'focus'];

exports.methods = methods;
var props = {
	src: _react.PropTypes.string,
	autosize: _react.PropTypes.bool,
	nodeintegration: _react.PropTypes.bool,
	plugins: _react.PropTypes.bool,
	preload: _react.PropTypes.string,
	httpreferrer: _react.PropTypes.string,
	useragent: _react.PropTypes.string,
	disablewebsecurity: _react.PropTypes.bool,
	partition: _react.PropTypes.string,
	allowpopups: _react.PropTypes.bool,
	blinkfeatures: _react.PropTypes.string,
	disableblinkfeatures: _react.PropTypes.string,
	guestinstance: _react.PropTypes.number,
	devtools: _react.PropTypes.bool,
	muted: _react.PropTypes.bool
};

exports.props = props;
var changableProps = {
	src: '__USE_ATTR__',
	useragent: 'setUserAgent',
	guestinstance: '__USE_ATTR__',
	devtools: 'setDevTools',
	muted: 'setAudioMuted'
};
exports.changableProps = changableProps;